--- old/usr/src/test/zfs-tests/cmd/scripts/zfstest.ksh	Wed Aug 31 16:20:18 2016
+++ new/usr/src/test/zfs-tests/cmd/scripts/zfstest.ksh	Wed Aug 31 16:20:18 2016
@@ -12,14 +12,16 @@
 #
 
 #
-# Copyright (c) 2012, 2015 by Delphix. All rights reserved.
+# Copyright (c) 2012, 2016 by Delphix. All rights reserved.
 # Copyright 2014, OmniTI Computer Consulting, Inc. All rights reserved.
 # Copyright 2016 Nexenta Systems, Inc.
 #
 
+export PATH="/usr/bin"
 export NOINUSE_CHECK=1
 export STF_SUITE="/opt/zfs-tests"
 export STF_TOOLS="/opt/test-runner/stf"
+export PATHDIR=""
 runner="/opt/test-runner/bin/run"
 auto_detect=false
 
@@ -31,9 +33,9 @@
 
 function find_disks
 {
-	typeset all_disks=$(echo '' | sudo -k /usr/sbin/format | awk \
+	typeset all_disks=$(echo '' | sudo -k format | awk \
 	    '/c[0-9]/ {print $2}')
-	typeset used_disks=$(/sbin/zpool status | awk \
+	typeset used_disks=$(zpool status | awk \
 	    '/c[0-9]*t[0-9a-f]*d[0-9]/ {print $1}' | sed 's/s[0-9]//g')
 
 	typeset disk used avail_disks
@@ -50,7 +52,7 @@
 
 function find_rpool
 {
-	typeset ds=$(/usr/sbin/mount | awk '/^\/ / {print $3}')
+	typeset ds=$(mount | awk '/^\/ / {print $3}')
 	echo ${ds%%/*}
 }
 
@@ -80,14 +82,46 @@
 {
 	typeset disk
 	for disk in $DISKS; do
-		sudo -k /usr/sbin/prtvtoc /dev/rdsk/${disk}s0 >/dev/null 2>&1
+		sudo -k prtvtoc /dev/rdsk/${disk}s0 >/dev/null 2>&1
 		[[ $? -eq 0 ]] || return 1
 	done
 	return 0
 }
 
-verify_id
+function create_links
+{
+	typeset dir=$1
+	typeset file_list=$2
 
+	[[ -n $PATHDIR ]] || fail "PATHDIR wasn't correctly set"
+
+	for i in $file_list; do
+		[[ ! -e $PATHDIR/$i ]] || fail "$i already exists"
+		ln -s $dir/$i $PATHDIR/$i || fail "Couldn't link $i"
+	done
+
+}
+
+function constrain_path
+{
+	. $STF_SUITE/include/commands.cfg
+
+	PATHDIR=$(/usr/bin/mktemp -d /var/tmp/constrained_path.XXXX)
+	chmod 755 $PATHDIR || fail "Couldn't chmod $PATHDIR"
+
+	create_links "/usr/bin" "$USR_BIN_FILES"
+	create_links "/usr/sbin" "$USR_SBIN_FILES"
+	create_links "/sbin" "$SBIN_FILES"
+	create_links "/opt/zfs-tests/bin" "$ZFSTEST_FILES"
+
+	# Special case links
+	ln -s /usr/gnu/bin/dd $PATHDIR/gnu_dd
+}
+
+constrain_path
+export PATH=$PATHDIR
+
+verify_id
 while getopts ac:q c; do
 	case $c in
 	'a')
@@ -133,6 +167,9 @@
 [[ $num_disks -lt 3 ]] && fail "Not enough disks to run ZFS Test Suite"
 
 # Ensure user has only basic privileges.
-/usr/bin/ppriv -s EIP=basic -e $runner $quiet -c $runfile
+ppriv -s EIP=basic -e $runner $quiet -c $runfile
+ret=$?
 
-exit $?
+rm -rf $PATHDIR || fail "Couldn't remove $PATHDIR"
+
+exit $ret
--- old/usr/src/test/zfs-tests/include/commands.cfg	Wed Aug 31 16:20:18 2016
+++ new/usr/src/test/zfs-tests/include/commands.cfg	Wed Aug 31 16:20:18 2016
@@ -10,161 +10,176 @@
 #
 
 #
-# Copyright (c) 2012, 2015 by Delphix. All rights reserved.
+# Copyright (c) 2016 by Delphix. All rights reserved.
 #
 
-export ARP="/usr/sbin/arp"
-export AWK="/usr/bin/awk"
-export BASENAME="/usr/bin/basename"
-export BC="/usr/bin/bc"
-export BUNZIP2="/usr/bin/bunzip2"
-export BZCAT="/usr/bin/bzcat"
-# bzip2, bunzip2 and bzcat prepend the contents of $BZIP2 or $BZIP to any
-# arguments. Setting BZIP2 here will lead to hard-to-diagnose unhappiness.
-export CAT="/usr/bin/cat"
-export CD="/usr/bin/cd"
-export CHGRP="/usr/bin/chgrp"
-export CHMOD="/usr/bin/chmod"
-export CHOWN="/usr/bin/chown"
-export CKSUM="/usr/bin/cksum"
-export CLRI="/usr/sbin/clri"
-export CMP="/usr/bin/cmp"
-export COMPRESS="/usr/bin/compress"
-export COREADM="/usr/bin/coreadm"
-export CP="/usr/bin/cp"
-export CPIO="/usr/bin/cpio"
-export CUT="/usr/bin/cut"
-export DATE="/usr/bin/date"
-export DD="/usr/bin/dd"
-export DEVFSADM="/usr/sbin/devfsadm"
-export DF="/usr/bin/df"
-export DIFF="/usr/bin/diff"
-export DIRCMP="/usr/bin/dircmp"
-export DIRNAME="/usr/bin/dirname"
-export DTRACE="/usr/sbin/dtrace"
-export DU="/usr/bin/du"
-export DUMPADM="/usr/sbin/dumpadm"
-export ECHO="/usr/bin/echo"
-export EGREP="/usr/bin/egrep"
-# Don't use $ENV here, because in ksh scripts it evaluates to
-# $HOME/.kshrc - likely not what you wanted.
-export FALSE="/usr/bin/false"
-export FDISK="/usr/sbin/fdisk"
-export FF="/usr/sbin/ff"
-export FGREP="/usr/bin/fgrep"
-export FILE="/usr/bin/file"
-export FIND="/usr/bin/find"
-export FIO="/usr/bin/fio"
-export FMADM="/usr/sbin/fmadm"
-export FMDUMP="/usr/sbin/fmdump"
-export FORMAT="/usr/sbin/format"
-export FSCK="/usr/sbin/fsck"
-export FSDB="/usr/sbin/fsdb"
-export FSIRAND="/usr/sbin/fsirand"
-export FSTYP="/usr/sbin/fstyp"
-export GETENT="/usr/bin/getent"
-export GETMAJOR="/usr/sbin/getmajor"
-export GNUDD="/usr/gnu/bin/dd"
-export GREP="/usr/bin/grep"
-export GROUPADD="/usr/sbin/groupadd"
-export GROUPDEL="/usr/sbin/groupdel"
-export GROUPMOD="/usr/sbin/groupmod"
-export GROUPS="/usr/bin/groups"
-export HEAD="/usr/bin/head"
-export HOSTNAME="/usr/bin/hostname"
-export ID="/usr/bin/id"
-export IOSTAT="/usr/bin/iostat"
-export ISAINFO="/usr/bin/isainfo"
-export KILL="/usr/bin/kill"
-export KSH="/usr/bin/ksh"
-export KSTAT="/usr/bin/kstat"
-export LABELIT="/usr/sbin/labelit"
-export LOCKFS="/usr/sbin/lockfs"
-export LOFIADM="/usr/sbin/lofiadm"
-export LOGNAME="/usr/bin/logname"
-export LS="/usr/bin/ls"
-export MD5SUM="/usr/bin/md5sum"
-export MDB="/usr/bin/mdb"
-export MKDIR="/usr/bin/mkdir"
-export MKFILE="/usr/sbin/mkfile"
-export MKTEMP="/usr/bin/mktemp"
-export MKNOD="/usr/sbin/mknod"
-export MODINFO="/usr/sbin/modinfo"
-export MODUNLOAD="/usr/sbin/modunload"
-export MOUNT="/usr/sbin/mount"
-export MPSTAT="/usr/bin/mpstat"
-export MV="/usr/bin/mv"
-export NAWK="/usr/bin/nawk"
-export NCHECK="/usr/sbin/ncheck"
-export NEWFS="/usr/sbin/newfs"
-export PACK="/usr/bin/pack"
-export PAGESIZE="/usr/bin/pagesize"
-export PAX="/usr/bin/pax"
-export PFEXEC="/usr/bin/pfexec"
-export PGREP="/usr/bin/pgrep"
-export PING="/usr/sbin/ping"
-export PKGINFO="/usr/bin/pkginfo"
-export PKILL="/usr/bin/pkill"
-export PPRIV="/usr/bin/ppriv"
-export PRINTF="/usr/bin/printf"
-export PRTVTOC="/usr/sbin/prtvtoc"
-export PS="/usr/bin/ps"
-export PSRINFO="/usr/sbin/psrinfo"
-export PWD="/usr/bin/pwd"
-export PYTHON="/usr/bin/python"
-export QUOTAON="/usr/sbin/quotaon"
-export READLINK="/usr/bin/readlink"
-export RCP="/usr/bin/rcp"
-export REBOOT="/usr/sbin/reboot"
-export RM="/usr/bin/rm"
-export RMDIR="/usr/bin/rmdir"
-export RSH="/usr/bin/rsh"
-export RUNAT="/usr/bin/runat"
-export SED="/usr/bin/sed"
-export SHARE="/usr/sbin/share"
-export SHUF="/usr/bin/shuf"
-export SLEEP="/usr/bin/sleep"
-export SORT="/usr/bin/sort"
-export STAT="/usr/bin/stat"
-export STRINGS="/usr/bin/strings"
-export SU="/usr/bin/su"
-export SUM="/usr/bin/sum"
-export SVCADM="/usr/sbin/svcadm"
-export SVCS="/usr/bin/svcs"
-export SWAP="/usr/sbin/swap"
-export SWAPADD="/sbin/swapadd"
-export SYNC="/usr/bin/sync"
-export TAIL="/usr/bin/tail"
-export TAR="/usr/sbin/tar"
-export TIMEOUT="/usr/bin/timeout"
-export TOUCH="/usr/bin/touch"
-export TR="/usr/bin/tr"
-export TRUNCATE="/usr/bin/truncate"
-export TRUE="/usr/bin/true"
-export TUNEFS="/usr/sbin/tunefs"
-export UFSDUMP="/usr/sbin/ufsdump"
-export UFSRESTORE="/usr/sbin/ufsrestore"
-export UMASK="/usr/bin/umask"
-export UMOUNT="/usr/sbin/umount"
-export UMOUNTALL="/usr/sbin/umountall"
-export UNAME="/usr/bin/uname"
-export UNCOMPRESS="/usr/bin/uncompress"
-export UNIQ="/usr/bin/uniq"
-export UNPACK="/usr/bin/unpack"
-export UNSHARE="/usr/sbin/unshare"
-export USERADD="/usr/sbin/useradd"
-export USERDEL="/usr/sbin/userdel"
-export USERMOD="/usr/sbin/usermod"
-export VMSTAT="/usr/bin/vmstat"
-export WAIT="/usr/bin/wait"
-export WC="/usr/bin/wc"
-export ZDB="/usr/sbin/zdb"
-export ZFS="/usr/sbin/zfs"
-export ZHACK="/usr/sbin/zhack"
-export ZINJECT="/usr/sbin/zinject"
-export ZLOGIN="/usr/sbin/zlogin"
-export ZLOOK="/usr/bin/zlook"
-export ZONEADM="/usr/sbin/zoneadm"
-export ZONECFG="/usr/sbin/zonecfg"
-export ZONENAME="/usr/bin/zonename"
-export ZPOOL="/usr/sbin/zpool"
+#
+# These variables are used by zfstest.ksh to constrain which utilities
+# may be used by the suite. The suite will create a directory which is
+# the only element of $PATH and create symlinks from that dir to the
+# binaries listed below.
+# Please keep the contents of each variable sorted for ease of reading
+# and maintenance.
+#
+export USR_BIN_FILES='awk
+    basename
+    bc
+    bunzip2
+    bzcat
+    cat
+    cd
+    chgrp
+    chmod
+    chown
+    cksum
+    cmp
+    compress
+    coreadm
+    cp
+    cpio
+    cut
+    date
+    dd
+    df
+    diff
+    dircmp
+    dirname
+    du
+    echo
+    egrep
+    expr
+    false
+    file
+    find
+    fio
+    getent
+    grep
+    head
+    hostname
+    id
+    iostat
+    isainfo
+    kill
+    ksh
+    logname
+    ls
+    md5sum
+    mdb
+    mkdir
+    mktemp
+    mpstat
+    mv
+    nawk
+    pack
+    pagesize
+    pax
+    pfexec
+    pgrep
+    pkginfo
+    pkill
+    ppriv
+    print
+    printf
+    ps
+    pwd
+    python
+    readlink
+    rm
+    rmdir
+    rsh
+    runat
+    sed
+    seq
+    shuf
+    sleep
+    sort
+    stat
+    strings
+    su
+    sudo
+    sum
+    svcs
+    sync
+    tail
+    timeout
+    touch
+    tr
+    true
+    truncate
+    umask
+    uname
+    uncompress
+    unpack
+    vmstat
+    wait
+    wc
+    xargs
+    zlook
+    zonename'
+
+export USR_SBIN_FILES='arp
+    clri
+    dtrace
+    dumpadm
+    ff
+    format
+    fsdb
+    fsirand
+    fstyp
+    getmajor
+    groupadd
+    groupdel
+    groupmod
+    labelit
+    lockfs
+    lofiadm
+    mkfile
+    mknod
+    ncheck
+    newfs
+    ping
+    prtvtoc
+    psrinfo
+    quotaon
+    share
+    svcadm
+    swap
+    tar
+    tunefs
+    ufsdump
+    ufsrestore
+    unshare
+    useradd
+    userdel
+    usermod
+    zdb
+    zhack
+    zinject
+    zoneadm
+    zonecfg'
+
+export SBIN_FILES='fdisk
+    mount
+    swapadd
+    umount
+    umountall
+    zfs
+    zpool'
+
+export ZFSTEST_FILES='chg_usr_exec
+    devname2devid
+    dir_rd_update
+    file_check
+    file_trunc
+    file_write
+    getholes
+    largest_file
+    mkbusy
+    mkfiles
+    mkholes
+    mktree
+    mmapwrite
+    randfree_file
+    readmmap
+    rename_dir
+    rm_lnkcnt_zero_file'
--- old/usr/src/test/zfs-tests/include/default.cfg	Wed Aug 31 16:20:18 2016
+++ new/usr/src/test/zfs-tests/include/default.cfg	Wed Aug 31 16:20:18 2016
@@ -28,7 +28,6 @@
 # Copyright (c) 2012, 2016 by Delphix. All rights reserved.
 #
 
-. $STF_SUITE/include/commands.cfg
 . $STF_SUITE/include/libtest.shlib
 
 # Define run length constants
@@ -40,25 +39,6 @@
 export ZONE_POOL="zonepool"
 export ZONE_CTR="zonectr"
 
-# Test Suite Specific Commands
-export CHG_USR_EXEC="/opt/zfs-tests/bin/chg_usr_exec"
-export DEVNAME2DEVID="/opt/zfs-tests/bin/devname2devid"
-export DIR_RD_UPDATE="/opt/zfs-tests/bin/dir_rd_update"
-export FILE_CHECK="/opt/zfs-tests/bin/file_check"
-export FILE_TRUNC="/opt/zfs-tests/bin/file_trunc"
-export FILE_WRITE="/opt/zfs-tests/bin/file_write"
-export GETHOLES="/opt/zfs-tests/bin/getholes"
-export LARGEST_FILE="/opt/zfs-tests/bin/largest_file"
-export MKBUSY="/opt/zfs-tests/bin/mkbusy"
-export MKFILES="/opt/zfs-tests/bin/mkfiles"
-export MKHOLES="/opt/zfs-tests/bin/mkholes"
-export MKTREE="/opt/zfs-tests/bin/mktree"
-export MMAPWRITE="/opt/zfs-tests/bin/mmapwrite"
-export RANDFREE_FILE="/opt/zfs-tests/bin/randfree_file"
-export READMMAP="/opt/zfs-tests/bin/readmmap"
-export RENAME_DIR="/opt/zfs-tests/bin/rename_dir"
-export RM_LNKCNT_ZERO_FILE="/opt/zfs-tests/bin/rm_lnkcnt_zero_file"
-
 # ensure we're running in the C locale, since
 # localised messages may result in test failures
 export LC_ALL="C"
@@ -139,7 +119,7 @@
 # Minimum vdev size possible as defined in the OS
 export SPA_MINDEVSIZE=$((64 * 1024 * 1024))
 
-export AUTO_SNAP=$($SVCS -a | $GREP auto-snapshot | $GREP online | $AWK \
+export AUTO_SNAP=$(svcs -a | grep auto-snapshot | grep online | awk \
     '{print $3}')
 
 # finally, if we're running in a local zone
